module sema.DType;

import tango.text.Util : jhash;

import sema.SymbolTable;

class DType
{
    Identifier id;
    Scope sc;
    DType actual;

    this(Identifier id, Scope sc, DType actual = null)
    {
        this.id = id;
        this.sc = sc;
        if (actual is null)
            this.actual = this;
        _name = id.get;
    }

    int opEquals(Object o)
    {
        if (auto t = cast(DType)o)
            return this.actual is t.actual;
        return 0;
    }

    int opCmp(Object o)
    {
        if (auto t = cast(DType)o)
            return cast(void*)this.actual - cast(void*)t.actual;
        return 0;
    }

    hash_t toHash()
    {
        return cast(hash_t)(cast(void*)this);
    }

    char[] name() { return _name; }

private:
    char[] _name;
}

class DStruct : DType
{
    this(Identifier id, Scope sc, DType actual = null)
    {
        super(id, sc, actual);
    }
    DType[] members;
}

class DFunction : DType
{
    this(Identifier id, Scope sc, DType actual = null)
    {
        super(id, sc, actual);
    }
    DType[] params;
    DType return_type;
}

